var databases = require("./jitsudb/databases");
var config = require("./jitsudb/config");
var engines = require("./jitsudb/engines");

var getdb = function (opts, cb) {

    // use Nodejitsu's api to request a list of databases
    databases.list(opts, function (err, body) {

        if (err) { throw err; };

        var dbNames = body.map( function (doc) {
            return doc.name;
        });

        if (-~dbNames.indexOf(opts.name)) {
            // Set up the db!
            var db = body[dbNames.indexOf(opts.name)];

            engines.engine(opts, db, cb);

        // Name is not in db, need to make new one!
        } else {
            databases.create(opts, function (err, body) {

                if (err) { throw err; }

                //need to try and get the url for the db again
                databases.list(opts, function (err, body) {
                    if (err) { throw err; };

                    var dbNames = body.map( function (doc) {
                        return doc.name;
                    });

                    var db = body[dbNames.indexOf(opts.name)];

                    engines.engine(opts, db, cb);
                });
                
            });
        }

    });
};

var jitsudb = module.exports = function(type, name, cb) {
    var opts = config;
    opts.name = name;
    opts.type = type;

    getdb(opts, function (url) {
        //Custom behavior based on database type
        cb(url);
    });
};
